import { ChartService } from '../../services/chart.service';
export class Sparkline {
    constructor() {
        this.chartService = new ChartService();
    }
    dataConfigHandler(newValue, oldValue) {
        console.log('firing', newValue, oldValue);
        if (newValue !== oldValue) {
            this.chart = this.create();
        }
    }
    componentDidLoad() {
        this.chart = this.create();
    }
    appendSVG(svg) {
        while (this.chartContainer.firstChild) {
            this.chartContainer.removeChild(this.chartContainer.firstChild);
        }
        this.chartContainer.appendChild(svg.node());
    }
    create() {
        console.log('dataConfig', this.dataConfig);
        this.dataConfig.data = this.chartService.formatData(this.dataConfig);
        this.dataConfig.config.dims = this.getDims();
        const svg = this.chartService.createSVG(this.dataConfig);
        const x = this.chartService.xAxis(svg, this.dataConfig);
        const y = this.chartService.yAxis(svg, this.dataConfig);
        this.chartService.line(svg, x, y, this.dataConfig);
        this.appendSVG(svg);
        return svg;
    }
    getDims() {
        const { height, width } = this.chartContainer.getBoundingClientRect();
        return { height, width };
    }
    render() {
        return (h("div", { class: "chart-container", ref: (el) => this.chartContainer = el }));
    }
    static get is() { return "anj-sparkline"; }
    static get properties() { return {
        "dataConfig": {
            "type": "Any",
            "attr": "data-config",
            "mutable": true,
            "watchCallbacks": ["dataConfigHandler"]
        }
    }; }
    static get style() { return "/**style-placeholder:anj-sparkline:**/"; }
}
